### Function

# Pango log2vis_get_embedding_levels

since: 1.4

#### Declaration [src]

    guint8*
    pango_log2vis_get_embedding_levels (
      const gchar* text,
      int length,
      PangoDirection* pbase_dir
    )

#### Description [src]

Return the bidirectional embedding levels of the input paragraph.

The bidirectional embedding levels are defined by the Unicode Bidirectional Algorithm.

If the input base direction is a weak direction, the direction of the characters in the text will determine the final resolved direction.

Available since: 1.4

#### Parameters

`text`

  Type: `const gchar*`

  The text to itemize.

  The data is owned by the caller of the function.
  The value is a NUL terminated UTF-8 string.

`length`

  Type: `int`

  The number of bytes (not characters) to process, or -1 if `text` is nul-terminated and the length should be calculated.

`pbase_dir`

  Type: `PangoDirection`

  Input base direction, and output resolved direction.

  The data is owned by the caller of the function.

#### Return value

Type: `guint8*`

A newly allocated array of embedding levels, one item per character (not byte), that should be freed using `g_free()`.

The data is owned by the called function.